SystemOrganization addCategory: #'Seaside-JSON-Component'!

WAComponent subclass: #WAJsonComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/27/2011 20:58'!
renderActionsOn: json
	"to be implemented by subclasses"! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/27/2011 20:58'!
renderChildrenOn: json
	self children do: [ :each |
		json render: each ]! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/27/2011 21:00'!
renderClassOn: json
	json render: self class name greaseString! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/27/2011 21:09'!
renderContentOn: json
	json object: [
		json key: 'class' value: [ self renderClassOn: json ].
		json key: 'state' value: [
			json object: [
				self renderStateOn: json ].
		json key: 'actions' value: [
			json object: [
				self renderActionsOn: json ] ].
		json key: 'children' value: [
			json array: [
				self renderChildrenOn: json ] ] ] ]! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/24/2011 11:31'!
renderJsonOn: aRenderer
	self renderWithContext: aRenderer context! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/27/2011 20:58'!
renderStateOn: json
	"to be implemented by stateful subclasses"! !

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/24/2011 10:00'!
rendererClass
	^ WAJsonCanvas! !

WAActionPhaseContinuation subclass: #WAJsonActionContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

WAJsonActionContinuation subclass: #WANonRedirectingJsonActionContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WANonRedirectingJsonActionContinuation methodsFor: 'testing' stamp: 'pmm 9/25/2011 19:11'!
shouldRedirect
	^ false! !

WAJsonActionContinuation subclass: #WARedirectingJsonActionContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WARedirectingJsonActionContinuation methodsFor: 'testing' stamp: 'pmm 9/25/2011 19:11'!
shouldRedirect
	^ true! !

WAAdmin subclass: #WAJsonAdmin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonAdmin class methodsFor: 'configuration' stamp: 'pmm 9/24/2011 10:49'!
applicationDefaults
	| config |
	config := WASharedConfiguration named: 'JSON Application Defaults'.
	(configuredApplicationDefaults ifNil: [ false ]) ifFalse: [
		self configureApplicationDefaults: config.
		configuredApplicationDefaults := true ].
	^ config! !

!WAJsonAdmin class methodsFor: 'initialization' stamp: 'pmm 9/25/2011 19:11'!
configureApplicationDefaults: aSharedConfiguration
	"WARenderLoopConfiguration is added by default because most users will use WASession and the Render Loop."
	(aSharedConfiguration parents includes: WAApplicationConfiguration instance) ifFalse: [
		aSharedConfiguration
			addParent: WAApplicationConfiguration instance;
			addParent: WARenderLoopConfiguration instance;
			at: #documentClass put: WAJsonDocument;
			at: #actionPhaseContinuationClass put: WANonRedirectingJsonActionContinuation;
			at: #renderPhaseContinuationClass put: WAJsonRenderContinuation;
			at: #mimeType put: 'application/json' ]! !

WARenderPhaseContinuation subclass: #WAJsonRenderContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonRenderContinuation methodsFor: 'processing' stamp: 'pmm 9/24/2011 10:07'!
handleRequest
	self respond: [ :response | self processRendering: response ].

	"The render phase should have returned a response"
	WAMissingResponseError signal! !

!WAJsonRenderContinuation methodsFor: 'processing' stamp: 'pmm 9/24/2011 10:10'!
processRendering: aResponse 
	| document actionContinuation renderContext actionUrl actionBaseUrl |
	"Prepare the response"
	aResponse contentType: self application contentType.

	"Create objects we need"
	document := self requestContext newDocument.
	actionContinuation := self createActionContinuation.
	renderContext := self createRenderContext.
	
	"Create URL"
	actionUrl := actionContinuation registerForUrl: false.
	actionBaseUrl := actionUrl copy.
	self updateUrl: actionUrl.

	"Hook objects together"
	renderContext
		document: document;
		actionUrl: actionUrl;
		actionBaseUrl: actionBaseUrl;
		resourceUrl: self application resourceBaseUrl.
	actionContinuation renderContext: renderContext.

	"Render"
	self presenter renderWithContext: renderContext.
	document close.
	renderContext destroy! !
